<?php
namespace Financeiro\Repositories;
use Geral\Util\Ambiente;
class Baixarecebida extends \Doctrine\ORM\EntityRepository
{
	public function queryValidaAdiantamentoUtilizado($cdfilial, $nrbaixarec){
    	try{
    		$sql = "SELECT A.NRBAIXAREC FROM (SELECT MAX(BO.NRBAIXAREC) NRBAIXAREC
					FROM BOLETRECEBER  BO, CONTARECEBER CR, ADIANTARECEB AR, TIPOCTRECEBER TR
					WHERE (BO.NRORG         = :P_NRORG       ) AND
					      (BO.CDFILIBAIREC  = :P_CDFILIAL    ) AND
			      		  (BO.NRBAIXAREC    = :P_NRBAIXAREC  ) AND
					      (CR.CDFILIBOLREC  = BO.CDFILIAL    ) AND
			    		  (CR.NRLANBOLREC   = BO.NRLANBOLREC ) AND
					      (CR.IDSTATREC     = 'B'            ) AND
			      		  (CR.CDFILIAL      = AR.CDFILIAL    ) AND
					      (CR.NRLANCTONF    = AR.NRLANCTONF  ) AND
			      		  (CR.NRSEQVENREC   = AR.NRSEQVENREC ) AND
					      (CR.NRPARCELAREC  = AR.NRPARCELAREC) AND
			      		  (TR.CDTPCTRECEB   = CR.CDTPCTRECEB ) AND
						  (TR.IDTPCTRECEBER = '2'            ))A";
			$params = array(
                'P_NRORG'    => Ambiente::getNrorg(),
				'P_CDFILIAL' => $cdfilial,
				'P_NRBAIXAREC' => $nrbaixarec
			);
			
			return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);
    	}catch(\Exception $e){
    		throw $e;
    	}
    }

    public function verificaBoletosBaixa($cdfilial, $nrbaixarec, $nrorg){
        $sql = <<<SQL
          SELECT 1
            FROM BAIXARECEBIDA BR
           WHERE EXISTS (SELECT 1
                          FROM BOLETRECEBER BO
                         WHERE BR.CDFILIAL   = BO.CDFILIBAIREC
                           AND BR.NRBAIXAREC = BO.NRBAIXAREC
                           AND BR.NRORG      = BO.NRORG)
             AND BR.CDFILIAL   = :P_CDFILIAL
             AND BR.NRBAIXAREC = :P_NRBAIXAREC
             AND BR.NRORG      = :P_NRORG
SQL;
        $params = array(
            "P_CDFILIAL"   => $cdfilial  ,
            "P_NRBAIXAREC" => $nrbaixarec,
            "P_NRORG"      => $nrorg     ,
        );

        return $this->getEntityManager()->getConnection()->fetchColumn($sql, $params);
    }
}